##!/bin/bash

#if [ $# -gt 1 ]; then
#    echo "Call this script without parameters or only with one parameter(installation path)." 
#	exit

if [ $# -ge 1 ]; then
	PORT=$1;
	else
	PORT=$[ 10000+ ( $RANDOM % 1000 )  + 1 ]
fi

if [ -z "$HOME" ]; then 
	PREFIX=/tmp
	else
	PREFIX=$HOME
fi

if [ $# -ge 2 ]; then
	INST_PATH=$2;
	else
	INST_PATH=$PREFIX"/inst"
fi

if [ -z "$LOGNAME" ]; then 
	export LOGNAME1=user$[ ( $RANDOM % 1000 )  + 1 ]
fi

CONFIG_FILE="config.log"
PYTHON_DIR_NAME="/python"
SIB_BIN_PATH=$INST_PATH/"bin"
SIB_LIB_PATH=$INST_PATH/"lib"
SIB_LIB64_PATH=$INST_PATH/"lib64"
SIB_INC_PATH=$INST_PATH/"include"
SIB_PKGC_PATH=$INST_PATH"/lib/pkgconfig/"

SIB_PY_PATH=$INST_PATH$PYTHON_DIR_NAME

mkdir -p $SIB_PY_PATH
mkdir -p $SIB_BIN_PATH
mkdir -p $SIB_LIB_PATH
mkdir -p $SIB_LIB64_PATH
mkdir -p $SIB_INC_PATH

export SIB_PORT=$PORT
export SIB_LIB_PATH=$SIB_LIB_PATH
export SIB_LIB64_PATH=$SIB_LIB64_PATH
export SIB_INC_PATH=$SIB_INC_PATH
export SIB_BIN_PATH=$SIB_BIN_PATH
export SIB_PY_PATH=$SIB_PY_PATH
export PYTHONPATH=$PYTHONPATH:$SIB_PY_PATH
export PKG_CONFIG_PATH=$PKG_CONFIG_PATH:$SIB_PKGC_PATH

echo "Local SIB configuration" > $CONFIG_FILE
echo " - installation path: " $INST_PATH >> $CONFIG_FILE
echo "(use this path with --prefix parameter for configure scripts)" >> $CONFIG_FILE
echo " - python path: " $SIB_PY_PATH  >> $CONFIG_FILE
echo "(you need to add this path to PYTHONPATH before starting sibd)" >> $CONFIG_FILE
echo " - SIB port:" $PORT >> $CONFIG_FILE

echo
cat  $CONFIG_FILE 
echo
echo "This script sets PYTHONPATH automatically for this session." 
echo
